/* Process model C form file: router.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char router_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A modeler 7 3EC0B77E 3EC0B77E 1 universi-lcur94 Roberta 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                              ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include <string.h>

// constants
#define LINK_NUMBER	4
#define INFINITY	16
#define DATA_PACKET	1
#define CONTROL_PACKET	2

// input streams:
#define FROM_APP	0
#define FROM_PHY3	1	
#define FROM_PHY2	2	
#define FROM_PHY1	3	
#define FROM_PHY0	4	

// output streams:
#define TO_APP	0
#define TO_PHY3	1	
#define TO_PHY2	2	
#define TO_PHY1	3	
#define TO_PHY0	4	

// conditions:
#define FROM_PHY	(intrpt_strm==FROM_PHY0 || intrpt_strm==FROM_PHY1 || intrpt_strm==FROM_PHY2 || intrpt_strm==FROM_PHY3)
#define PHY_LAYER_PKT_ARVL	(intrpt_type == OPC_INTRPT_STRM && FROM_PHY)
#define APP_LAYER_PKT_ARVL	(intrpt_type == OPC_INTRPT_STRM && intrpt_strm == FROM_APP)

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		node_id;
	const char*	            		node_name;
	double	                 		link_cost[LINK_NUMBER];
	FILE *	                 		log;
	const char*	            		destination;
	} router_state;

#define pr_state_ptr            		((router_state*) SimI_Mod_State_Ptr)
#define node_id                 		pr_state_ptr->node_id
#define node_name               		pr_state_ptr->node_name
#define link_cost               		pr_state_ptr->link_cost
#define log                     		pr_state_ptr->log
#define destination             		pr_state_ptr->destination

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	router_state *op_sv_ptr = pr_state_ptr;


/* Function Block */

enum { _block_origin = __LINE__ };
void packet_from_source(Packet * pk) {
	Packet * packet;
	
	FIN(packet_from_source(Packet*));
	
	if (strcmp(destination, node_name)==0) {
		op_pk_destroy(pk);
		FOUT;
	}
	packet=op_pk_create_fmt("bf_packet");
	op_pk_nfd_set(packet, "command", DATA_PACKET);
	op_pk_nfd_set(packet, "source_address", node_id);
	op_pk_nfd_set(packet, "hops", 0);
	op_pk_nfd_set(packet, "data", pk);
	op_pk_send(packet, TO_PHY0);
	
	fprintf(log, "%f %d ho generato e inviato un pacchetto\n", op_sim_time(), node_id);
	
	FOUT;		
}

void packet_from_physical_layer(Packet * pk) {
	int kind;
	int source;
	Packet* inner;

	FIN(packet_from_physical_layer(Packet*));
	
	op_pk_nfd_get(pk, "command", &kind);
	op_pk_nfd_get(pk, "source_address", &source);
	switch (kind) {
		case DATA_PACKET:
			if (strcmp(destination, node_name)==0) {
				op_pk_nfd_get(pk, "data", &inner);
				op_pk_send(inner, TO_APP);
				fprintf(log, "%f %d accetto il pacchetto (destination=%s)\n", op_sim_time(), node_id, destination);
			} else {
				op_pk_nfd_set(pk, "source_address", node_id);
				op_pk_send(pk, TO_PHY0);
			}
			fprintf(log, "%f %d ho ricevuto un pacchetto da %d\n", op_sim_time(), node_id, source);
			break;
		case CONTROL_PACKET:
			break;
		default:
			break;
	}
	FOUT;
}

/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void router (void);
	Compcode router_init (void **);
	void router_diag (void);
	void router_terminate (void);
	void router_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
router (void)
	{
	int _block_origin = 0;
	FIN (router ());
	if (1)
		{
		Packet*				pkptr;
		int					intrpt_type = OPC_INT_UNDEF;
		int					intrpt_strm = OPC_INT_UNDEF;


		FSM_ENTER (router)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "router [init enter execs]")
				FSM_PROFILE_SECTION_IN ("router [init enter execs]", state0_enter_exec)
				{
				int i;
				
				// prendo l'id del nodo di cui faccio parte
				node_id=op_topo_parent(op_id_self());
				
				// prendo il nome del nodo
				node_name = (char*)op_prg_mem_alloc(sizeof(char)*20);
				op_ima_obj_attr_get(node_id, "name", node_name);
				
				// apro un file di log
				log=fopen("log.txt", "a");
				
				// imposto tutti a "infinito" i costi dei link
				for (i=0; i<LINK_NUMBER; i++) {
					link_cost[i]=INFINITY;
				}
				
				// prendo il nome del nodo destinazione
				destination = (char*)op_prg_mem_alloc(sizeof(char)*20);
				op_ima_sim_attr_get(OPC_IMA_STRING, "destination", destination);
				
				fprintf(log, "%d = %s\n", node_id, node_name);
				fclose(log);
				log=fopen("log.txt", "a");
				}

				FSM_PROFILE_SECTION_OUT ("router [init enter execs]", state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "router [init exit execs]")
				FSM_PROFILE_SECTION_IN ("router [init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("router [init exit execs]", state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "wait")
				/*---------------------------------------------------------*/



			/** state (wait) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "wait", "router [wait enter execs]")
				FSM_PROFILE_SECTION_IN ("router [wait enter execs]", state1_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("router [wait enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,router)


			/** state (wait) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "wait", "router [wait exit execs]")
				FSM_PROFILE_SECTION_IN ("router [wait exit execs]", state1_exit_exec)
				{
				intrpt_type = op_intrpt_type ();
				intrpt_strm = op_intrpt_strm ();
				pkptr = op_pk_get (intrpt_strm);
				}
				FSM_PROFILE_SECTION_OUT ("router [wait exit execs]", state1_exit_exec)


			/** state (wait) transition processing **/
			FSM_PROFILE_SECTION_IN ("router [wait trans conditions]", state1_trans_conds)
			FSM_INIT_COND (APP_LAYER_PKT_ARVL)
			FSM_TEST_COND (PHY_LAYER_PKT_ARVL)
			FSM_TEST_LOGIC ("wait")
			FSM_PROFILE_SECTION_OUT ("router [wait trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "APP_LAYER_PKT_ARVL", "", "wait", "app layer arr")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PHY_LAYER_PKT_ARVL", "", "wait", "phy layer arr")
				}
				/*---------------------------------------------------------*/



			/** state (app layer arr) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "app layer arr", "router [app layer arr enter execs]")
				FSM_PROFILE_SECTION_IN ("router [app layer arr enter execs]", state2_enter_exec)
				{
				packet_from_source(pkptr);
				}

				FSM_PROFILE_SECTION_OUT ("router [app layer arr enter execs]", state2_enter_exec)

			/** state (app layer arr) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "app layer arr", "router [app layer arr exit execs]")
				FSM_PROFILE_SECTION_IN ("router [app layer arr exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("router [app layer arr exit execs]", state2_exit_exec)


			/** state (app layer arr) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "app layer arr", "wait")
				/*---------------------------------------------------------*/



			/** state (phy layer arr) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "phy layer arr", "router [phy layer arr enter execs]")
				FSM_PROFILE_SECTION_IN ("router [phy layer arr enter execs]", state3_enter_exec)
				{
				packet_from_physical_layer(pkptr);
				}

				FSM_PROFILE_SECTION_OUT ("router [phy layer arr enter execs]", state3_enter_exec)

			/** state (phy layer arr) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "phy layer arr", "router [phy layer arr exit execs]")
				FSM_PROFILE_SECTION_IN ("router [phy layer arr exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("router [phy layer arr exit execs]", state3_exit_exec)


			/** state (phy layer arr) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "phy layer arr", "wait")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,router)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
router_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (router_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (router)",
			sizeof (router_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((router_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
router_diag (void)
	{
	/* No Diagnostic Block */
	}




void
router_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (router_terminate (void))

	if (1)
		{
		Packet*				pkptr;
		int					intrpt_type = OPC_INT_UNDEF;
		int					intrpt_strm = OPC_INT_UNDEF;

		/* Termination Block */


		BINIT
		{
		fclose(log);
		}

		/* End of Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in router_svar function. */
#undef node_id
#undef node_name
#undef link_cost
#undef log
#undef destination



void
router_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	router_state		*prs_ptr;

	FIN (router_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (router_state *)gen_ptr;

	if (strcmp ("node_id" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->node_id);
		FOUT
		}
	if (strcmp ("node_name" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->node_name);
		FOUT
		}
	if (strcmp ("link_cost" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->link_cost);
		FOUT
		}
	if (strcmp ("log" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->log);
		FOUT
		}
	if (strcmp ("destination" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->destination);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

